package eclipselink.cloning;

import static javax.persistence.DiscriminatorType.STRING;
import static javax.persistence.FetchType.LAZY;
import static javax.persistence.InheritanceType.SINGLE_TABLE;

import javax.persistence.Column;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="EMPLOYEE")
@Inheritance(strategy=SINGLE_TABLE)
@DiscriminatorColumn(name="TYPE",discriminatorType=STRING)
public abstract class Employee extends AbstractObject
{
    @Id
    @Column(name="EMPLOYEE_ID")
    private int id;
    
    /**
     * The general service to which this attribute belongs.
     */
    @ManyToOne(fetch=LAZY)
    @JoinColumn(name="DEPARTMENT_FK")
    private Department department;
    
    @Column
    private String name;
    
    public String getName()
    {
    	return name;
    }
    
    public Department getDepartment()
    {
    	return department;
    }
    
    public void setDepartment(Department newValue)
    {
    	department = newValue;
    }
    
    @Override
    public Object clone()
    throws CloneNotSupportedException
    {
    	Employee result = (Employee) super.clone();

        //result.department = null;
        result.setDepartment(null);

        return result;
    }
}
